<template>
<v-container>
    <v-card
    elevation="2"
    outlined
    shaped
    class="card">
    <h1 class="text-center">Make changes to room "<b>{{room.name}}</b>"</h1>
    <room-form :room="room" @save-changes-click="makeChangesToRoom">
    </room-form>
    <v-row justify="center">
        <v-btn v-if="timeslots.length==0" outlined color="primary" @click="showTimeslot();addTimeslot();" >Create a Timeslot</v-btn>
    </v-row>
    <v-divider></v-divider>
         <div v-if="timeslots.length>0">
    <h2 class="text-center">Timeslot(s)</h2>
                <v-card-title class="justify-center">Here you can create, edit and delete timeslots so certain devices will turn on at specific times.</v-card-title>
        <time-slot-table :timeslots="timeslots"
        @delete-timeslot="deleteTimeslot"
        ></time-slot-table>
    <v-row justify="center">
    <v-btn color="primary" outlined @click="addTimeslot">Create an extra timeslot</v-btn>
    </v-row>
    <v-row justify="center">
        <v-btn color="primary" @click="saveTimeslots">Save timeslots</v-btn>
    </v-row>
    </div>
    <v-snackbar v-model="errorInfo.showError" color="error">
        {{ errorInfo.errorMessage }}
    </v-snackbar>
    <v-snackbar v-model="successInfo.showMessage" color="success">
        {{ successInfo.succesMessage }}
    </v-snackbar>
    </v-card>
    </v-container>
</template>

<script>
import RoomForm from "@/components/RoomForm"
import RoomService from "@/services/RoomService"
import TimeSlotTable from "@/components/TimeSlotTable"
import TimeslotService from "@/services/TimeslotService"

export default {
    name: "RoomDetail",
    components: {
        RoomForm,
        TimeSlotTable
    },
    props: [
        "roomName",
        "floorId"
    ],
    data: () => ({
        room: {
            type: Object,
            required: true
        },
        errorInfo: {
            showError: false,
            errorMessage: "",
        },
        successInfo: {
            showMessage: false,
            succesMessage: "",
        },
        timeslots:{
            type: Array,
            required:false
        }
    }),
    async created() {
        await this.loadRoom(this.floorId,this.roomName);
        await this.loadTimeslots(this.room.id);
    },
    methods: {
        loadRoom(floorId,roomName){
            return RoomService.getByNameAndFloorId(floorId,roomName).then((rooms) => {
                //Get room out of array
                rooms.forEach(room => {
                    this.room = room
                });
            })
            .catch((error) => {
                this.handleError("Loading room failed",error);
            });
        },
        addTimeslot(){
                this.timeslots.push({"room_id":this.room.id,element:"","value":"","startTime":"","endTime":""})
        },
        loadTimeslots(roomId){
            TimeslotService.getByRoomId(roomId).then((timeslots) =>{
                this.timeslots = timeslots
            }).catch((error) => {
                this.handleError("Loading timeslots failed",error);
            });
        },
        saveTimeslots(){
            this.timeslots.forEach(timeslot => {
                if(timeslot.element==null||timeslot.value==null||timeslot.startTime==null||timeslot.endTime==null){
                    this.handleError("Timeslot needs to be filled completely!",null)
                }else if(timeslot.id!=null){
                    TimeslotService.put(timeslot)
                    .catch((error) => {
                    this.handleError("Saving timeslot failed",error);
                });
                }else{
                    TimeslotService.post(timeslot)
                    .catch((error) => {
                    this.handleError("Saving timeslot failed",error);
                });
                }
            this.handleSuccess("Timeslots successfully saved!")
            });
        },
        deleteTimeslot(timeslot){
            TimeslotService.delete(timeslot).then(this.handleSuccess("Timeslot successfully deleted!")).then(this.loadTimeslots(this.roomId))
            .catch((error) => {
            this.handleError("Deleting timeslot failed",error);
         });
        },
        showTimeslot(){
            this.amountOfTimeSlots++;
        },
        makeChangesToRoom(room){
            RoomService.put(room).then(this.roomName!=room.name?this.$router.push({ name: "roomName", params: {floorId: room.floor_id ,roomName: room.name }}):null)
            this.handleSuccess("Room successfully saved!")
        },
        handleError(userMessage, error){
            this.errorInfo.errorMessage = userMessage;
            this.errorInfo.showError = true;
            console.log(error);
        },
        handleSuccess(userMessage){
            this.successInfo.succesMessage = userMessage;
            this.successInfo.showMessage = true;
        }
    }
};
</script>